Attribute VB_Name = "OraTools"
Option Explicit


#Const T_DEBUG = True
Global ConnectString As String
Global WS As Workspace
Global BaseExterne As String    'Pour clause IN
Global BaseInterne As String
Global DBInt As DataBase
Global DBExt As DataBase
Global DBAttached As DataBase
Global DBUser As DataBase
Global Rs As Recordset
Global Rst As Recordset
Global AllowFlash As Boolean
Global FlashSQL As String
Global FlashRs As Recordset
Global CPWD As String

Global OraSession As Object
Global OraSassion As Object
Global OraDataBase As Object


Function ExecSqlReq(Base As DataBase, Rst As Recordset, Sql As String) As Integer
'Retourne 0 si succes, code erreur sinon
    
    On Error Resume Next
    Set Rst = Base.OpenRecordset(Sql, dbOpenSnapshot, dbSQLPassThrough)
    If Err Then
        ExecSqlReq = Err
        Clipboard.SetText Sql
        If MsgBox(Sql, vbYesNo + vbDefaultButton1 + vbQuestion, Err & " " & Err.Description & " Continuer ?") = vbNo Then
            End
        End If
        Err.Clear
    End If
    If Rst.RecordCount < 1 Then
        ExecSqlReq = -1 'Nothing found
    End If
End Function
Function ExecSqlCmd(Base As DataBase, Sql As String) As Integer
'Retourne 0 si succes, code erreur sinon

    On Error Resume Next
    Base.Execute Sql, dbSQLPassThrough
    If Err Then
        ExecSqlCmd = Err
        Clipboard.SetText Sql
        If MsgBox(Sql, vbYesNo + vbDefaultButton1 + vbQuestion, Err & " " & Err.Description & " Continuer ?") = vbNo Then
            End
        End If
        Err.Clear
    End If
End Function
Function ExecuteSqlActionScript(Base As DataBase, Script As String) As Integer
' Excute sur la base "Base" l'action SQL dcrite par "Script".
' "Script" peut etre une action SQL ou un nom de fichier
' Si "Script" est un nom de fichier toutes les lignes du fichier sont considres
' comme une action SQL.
' Retourne 0 si la (les) actions ont pu etre excutes.
' Retourne le code erreur sinon.
' Si "Script" etait un nom de fichier, il contient la ligne du fichier ayant
' provoqu l'erreur.
' Cette fonction ne peut pas excuter de requettes SQL, utiliser ExecSqlReq
Dim F As Integer
Dim Ligne As String
Dim Suite As String
    
    ExecuteSqlActionScript = 0
    If FileExists(Script) Then 'Le script est un fichier
        F = FreeFile
        Open Script For Input As F
        Do While Not EOF(F)
            Line Input #F, Ligne
            Ligne = Trim$(Ligne)
            If (InStr(Ligne, ";") <> 1) And (Len(Ligne) > 0) Then
                Do While (InStr(Ligne, "\") = Len(Ligne)) And (Not EOF(F))
                    Line Input #F, Suite
                    Ligne = Left$(Ligne, Len(Ligne) - 1) & Suite
                Loop
                On Error Resume Next
                Base.Execute Ligne, dbFailOnError
                If Err Then
                    ExecuteSqlActionScript = Err
                    Script = Ligne
                    On Error GoTo 0
                    Exit Do
                End If
                On Error GoTo 0
            End If
        Loop
        Close F
    Else
        On Error Resume Next
        Base.Execute Script, dbFailOnError
        If Err Then
            ExecuteSqlActionScript = Err
            On Error GoTo 0
        End If
    End If
End Function

Function DoSqlActionScript(Base As DataBase, Script As String) As Integer
' Comme ci dessus mais pour les scripts avec actions SQL sur plusieurs lignes
' spares par des ';'
Dim F As Integer
Dim S As String
Dim Ligne As String
Dim Suite As String
    
    DoSqlActionScript = 0
    If FileExists(Script) Then 'Le script est un fichier
        F = FreeFile
        Open Script For Input As F
        Do While Not EOF(F)
            Line Input #F, S
            S = Trim$(S)
            Ligne = Ligne & S & Chr$(13) & Chr$(10)
            If InStr(S, ";") Then
'                On Error Resume Next
'                Debug.Print Ligne
                Base.Execute Ligne, dbFailOnError
                If Err Then
                    DoSqlActionScript = Err
                    Script = Ligne
                    On Error GoTo 0
                    Exit Do
                End If
                Ligne = ""
                On Error GoTo 0
            End If
DoSqlActionScript_Next:
        Loop
        Close F
    Else
'        On Error Resume Next
        Base.Execute Script, dbFailOnError
        If Err Then
            DoSqlActionScript = Err
'            On Error GoTo 0
        End If
    End If
End Function
Function DateToChar8(InDate As String) As String
    DateToChar8 = ""
    If IsDate(InDate) Then DateToChar8 = Format(CDate(InDate), "yyyymmdd")
End Function
Function Char8ToDate(Char8 As String) As Date
Dim Y As String
Dim M As String
Dim J As String
    
    On Error Resume Next
    Y = Left$(Char8, 4)
    M = Mid$(Char8, 5, 2)
    J = Mid$(Char8, 7, 2)
    Char8ToDate = CDate(J & "/" & M & "/" & Y)
    On Error GoTo 0
End Function
Function ConnecteBase(CryptedPwd As Boolean) As Boolean
Dim S As String
Dim T As String

    On Error Resume Next
    T = GetIniString(INIFILE, "DATABASE", "Oracle")
    If Len(T) Then
        OraConnect
        Exit Function
    End If
    ConnecteBase = True
    T = GetIniString(INIFILE, "DATABASE", "ExternalConnectString")
    If Len(T) Then
        BaseExterne = T
        Err.Clear
        If InStr(T, "ODBC;") Then
            If CryptedPwd Then
                S = Substring(T, 4, "=")    'PWD
                T = Substring(T, 1, S)      'Sans PWD
'''                S = Encrypt(S, App.EXEName)
'                S = Substring(S, 1, App.EXEName)
                CPWD = S
                T = T & S             'Avec PWD decrypt
            End If
            Set DBExt = Workspaces(0).OpenDatabase("", False, False, T)
        Else
            Set DBExt = Workspaces(0).OpenDatabase(T)
        End If
        If Err Then
            ConnecteBase = False
        End If
    End If
    T = GetIniString(INIFILE, "DATABASE", "InternalConnectString")
    If Len(T) Then
        BaseInterne = T
        Set DBInt = Workspaces(0).OpenDatabase(T, False, False)
        If Err Then
            ConnecteBase = False
        End If
    End If
End Function
Function OraConnect() As Boolean
Dim S As String
Dim Base As String
Dim User As String
Dim Sql As String
Dim Ods As Object
    
    S = GetIniString(INIFILE, "DATABASE", "ORACLE")
    If Len(S) Then
        Base = Substring(S, 1, ",")
        User = Substring(S, 2, ",")
        Set OraSession = CreateObject("OracleInProcServer.XOraSession")
        Set OraDataBase = OraSession.OpenDatabase(Base, User, 0&)
        OraConnect = True
'        Sql = "Select * from " & TBDONGLE
'        Set Ods = OraDataBase.DbCreateDynaset(Sql, 0&)
'
'
'        Set Ods = Nothing
    End If
    
End Function
Sub EnableFlash()


    If Not AllowFlash Then
        If MsgBox("Passer en mode test ?" & vbCrLf & _
                "(Fin du mode test par MAJ + F12)", vbYesNo) = vbYes Then
            AllowFlash = True
            ShowFlash ""
        End If
    Else
        MsgBox "Fin du mode test"
        AllowFlash = False
    End If
End Sub

Sub ShowFlash(SQLText)
''    If AllowFlash Then
'        FlashSQL = SQLText
'        FlashForm.Show 1
''    End If
End Sub
Function DupliqueQuote(V As String) As String
Dim J As Integer
Dim S As String
Dim C As String

    If Len(V) = 0 Then
        DupliqueQuote = "''"
        Exit Function
    End If
    For J = 1 To Len(V)
        C = Mid$(V, J, 1)
        If C = "'" Then C = "''"
        DupliqueQuote = DupliqueQuote & C
    Next J
    DupliqueQuote = "'" & DupliqueQuote & "'"
End Function

Public Sub DbCompact(BasePath As String)
' Rpare et compacte la base locale Acces
' L'application doit tre suspendue
'Dim BasePath As String
Dim Sauve As String
Dim Nouveau As String

'    BasePath = GetIniString(INIFILE, "DATABASE", "InternalConnectString")
    If FileExists(BasePath) Then    'Ca doit tre une base Access
        DBInt.Close     'Ferme la base locale
        Sauve = GetPath(BasePath) & "\" & Substring(GetFname(BasePath), 1, ".") & Format$(Weekday(Now), "\.000")
        Nouveau = GetPath(BasePath) & "\" & Substring(GetFname(BasePath), 1, ".") & ".tmp"
        Copy BasePath, Sauve, 1, True
        DBEngine.RepairDatabase BasePath
        DBEngine.CompactDatabase BasePath, Nouveau
        Delete BasePath, 1
        Rename Nouveau, BasePath, 1, True
        Set DBInt = Workspaces(0).OpenDatabase(BasePath, False, False) 'Rouvre la base rpare et compacte.
    End If
End Sub

Public Function DayToInt(D As Date) As Integer
' Retourne un entier reprsentant un jour (MMDD)
    
    DayToInt = (100 * Val(Month(D))) + (Val(Day(D)))
End Function

Public Function TimeToInt(T As Date) As Integer
'Retourne un entier reprsentant une heure

    TimeToInt = (100 * Val(Hour(T))) + (Val(Minute(T)))
End Function
Public Function TimeStringToInt(S As String) As Integer
'Retourne un entier  partir d'une chaine reprsentant une heure

    TimeStringToInt = (100 * Val(Left$(S, 2))) + Val(Right$(S, 2))

End Function

Public Function IntToDay(I As Integer) As Date
' Retourne le jour correspondant  l'entier pass en paramtre
Dim D As Integer
Dim M As Integer

    D = I Mod 100
    M = I \ 100
    IntToDay = CDate(Format(D) & "/" & Format(M))    'IntToDayString(I, ""))
End Function

Public Function IntToTime(I As Integer) As Date
' Retourne l'heure correspondant  l'entier pass en paramtre

    IntToTime = CDate(IntToTimeString(I, ""))
End Function

Public Function IntToDayString(I As Integer, F As String) As String
' Retourne une chaine reprsentant un jour, selon F (Format). Par dfaut: "dd:mm"
    
    If Len(F) = 0 Then F = "00/00"
    IntToDayString = Format$(I, F)
End Function

Public Function IntToTimeString(I As Integer, F As String) As String
' Retourne une chaine reprsentant une heure, selon F (Format). Par dfaut: "hh:mm"

    If Len(F) = 0 Then F = "00:00"
    IntToTimeString = Format$(I, F)
End Function

Public Function DateToLong(D As Date) As Long
' Retourne un entier long reprsenatnt la date

    DateToLong = (10000 * Val(Year(D))) + (100 * Val(Month(D))) + (Val(Day(D)))
End Function

Public Function LongToDateString(L As Long, F As String) As String
' Retourne une chaine reprsentant la date selon F (Format). Par dfaut : "dd:mm:yyyy"

    If Len(F) = 0 Then F = "dd/mm/yyyy"
    LongToDateString = Format$(L, F)
End Function

Public Function LongToDate(L As Long) As Date
' Retourne la date correspondant  l'entier long pass en paramtre

    LongToDate = CDate(LongToDateString(L, ""))
End Function

Public Function ITimeToM(ITime As Integer) As Integer
' Retourne le nombre de minutes depuis 00:00 reptsent par ITime
Dim M As Integer
Dim H As Integer
        
    M = ITime Mod 100
    H = ITime \ 100
    ITimeToM = (H * 60) + M
End Function
Public Function MToItime(M As Integer) As Integer
' Retourne un entier reprsentant l'heure selon nombre de minutes reu en parametre

    MToItime = (100 * (M \ 60)) + (M Mod 60)
End Function
Public Function GetFreeId(Base As DataBase, Table As String, Champ As String, Maximum As Long) As Long
' Retourne un identifiant unique libre pour cette table et ce champ.
' Le nombre d'enregistrements autoris dans cette table est 'Maximum'
Dim I As Long
Dim Sql As String
Dim Rs As Recordset
Static IdLimit As Long

'    Rnd (-X)
'    Randomize 555
    If IdLimit = 0 Then IdLimit = 2 ^ 30        'Une seule fois !
    For I = 1 To Maximum                       'Nb d'entres autorises dans la table
        GetFreeId = 1 + (IdLimit * Rnd)    'Jamais 0
        Sql = "Select " & Champ & " From " & Table & " Where " & Champ & " = " & GetFreeId
        If ExecSqlReq(Base, Rs, Sql) = -1 Then Exit Function      'OK
    Next I
    GetFreeId = -1      'Plus de place
End Function
Public Function AdjustIntDay(IntDay As Integer) As Integer
Dim M As Integer
Dim D As Integer
    
    M = IntDay \ 100
    D = IntDay Mod 100

    If D < 1 Then
        D = D + 31
        M = M - 1
    End If
    If M < 1 Then
        M = M + 12
    End If
    Do While D > 31
        M = M + 1
        D = D - 31
    Loop
    Do While M > 12
        M = M - 12
    Loop
    AdjustIntDay = (100 * M) + D
End Function

Public Function GetNextId(Sequence As String) As Double
Dim Sql As String
Dim Rs As Recordset

    Sql = "Select " & Sequence & ".NEXTVAL as MyId From DUAL"
    ExecSqlReq DBExt, Rs, Sql
    GetNextId = Rs!MyId
End Function

